<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('jifen.使用积分数量')" prop="points">
        <el-input
          v-model="queryParams.points"
          placeholder=""
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('jifen.订单金额')" prop="orderCondition">
        <el-input
          v-model="queryParams.orderCondition"
          placeholder=""
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('jifen.启用状态')" prop="isEnabled">
        <el-select v-model="queryParams.isEnabled" placeholder="" clearable>
          <el-option
            :label="$t('jifen.开启')"
            :value="1"
          />
          <el-option
            :label="$t('jifen.关闭')"
            :value="0"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{$t('jifen.搜索')}}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{$t('jifen.重置')}}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:tier:add']"
        >{{$t('jifen.新增')}}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:tier:edit']"
        >{{$t('jifen.修改')}}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:tier:remove']"
        >{{$t('jifen.删除')}}
        </el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="warning"-->
<!--          plain-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          @click="handleExport"-->
<!--          v-hasPermi="['system:tier:export']"-->
<!--        >导出-->
<!--        </el-button>-->
<!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="tierList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="id" align="center" prop="id"/>
      <el-table-column :label="$t('jifen.使用积分数量')" align="center" prop="points"/>
      <el-table-column :label="$t('jifen.订单金额')" align="center" prop="orderCondition"/>
      <el-table-column :label="$t('jifen.启用状态')" align="center" prop="isEnabled">
        <template slot-scope="scope">
          <div v-if="scope.row.isEnabled==1">{{ $t('jifen.开启') }}</div>
          <div v-if="scope.row.isEnabled==0">{{ $t('jifen.关闭') }}</div>
        </template>
      </el-table-column>
      <el-table-column :label="$t('jifen.操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:tier:edit']"
          >{{ $t('jifen.修改') }}
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:tier:remove']"
          >{{ $t('jifen.删除') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改积分使用梯次对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label=" $t('jifen.使用积分数量')" prop="points">
          <el-input v-model="form.points" :placeholder="$t('jifen.请输入使用积分数量')"/>
        </el-form-item>
        <el-form-item :label=" $t('jifen.订单金额')" prop="orderCondition">
          <el-input v-model="form.orderCondition" :placeholder="$t('jifen.订单金额达到该金额时生效')"/>
        </el-form-item>
        <el-form-item :label="$t('jifen.启用状态')" prop="isEnabled">
          <el-radio-group v-model="form.isEnabled">
            <el-radio :label="1">{{ $t('jifen.开启') }}</el-radio>
            <el-radio :label="0">{{ $t('jifen.关闭') }}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('jifen.确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('jifen.取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {listTier, getTier, delTier, addTier, updateTier} from "@/api/system/pointTier";

export default {
  name: "Tier",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 积分使用梯次表格数据
      tierList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        points: null,
        orderCondition: null,
        isEnabled: null,
        isDeleted: 0,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        points: [
          {required: true, message:this.$t("使用积分数量不能为空"), trigger: "blur"}
        ],
        orderCondition: [
          {required: true, message: this.$t("订单金额不能为空"), trigger: "blur"}
        ],
        isEnabled: [
          {required: true, message: this.$t("启用状态不能为空"), trigger: "blur"}
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询积分使用梯次列表 */
    getList() {
      this.loading = true;
      listTier(this.queryParams).then(response => {
        this.tierList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        points: null,
        orderCondition: null,
        isEnabled: null,
        isDeleted: null,
        createTime: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('jifen.新增');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getTier(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title =this.$t('jifen.修改');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateTier(this.form).then(response => {
              this.$modal.msgSuccess(this.$t("jifen.修改成功"));
              this.open = false;
              this.getList();
            });
          } else {
            addTier(this.form).then(response => {
              this.$modal.msgSuccess(this.$t("jifen.新增成功"));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除数据项？').then(function () {
        return delTier(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/tier/export', {
        ...this.queryParams
      }, `tier_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
